// Copyright 2007 Rene Laterveer, SMS Mac, SMS Vista
// All rights reserved

// 2.0   - long sms
//       - different graphics for docked and undocked state
//       - show full name in head
//       - truncate long name in head with ellipses
//       - add Google Analytics tagging to openURL
//       - add tooltips to elements on front of gadget

// 2.1   - Trial SMS Account Support
//       - use g:background for rendering to solve problem with strange pixels


var editable = false;
var backside = false;

var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, element:null, celement:null, melement:null, timer:null};

var textSMS = "";
var status = false;

var trialAccount = false;

function doChars(elem)
{
	var txt = elem.value;//elem.innerText;
	var n = txt.length;
	var value = txt.charCodeAt(n-1);
	
	// ignore dead keys
	if (value == 96 || value == 94 || value == 168 || value == 176 || value == 180 || value == 710 || value == 732) {
		txt = txt.substring(0, n-1);
	}
	
	setMetrics(txt);
}

function setName(txt)
{
	var head = document.getElementById("head");
	if (head != null)
		head.innerText = txt;
}

function setStatusText(txt)
{
	status = true;
	textSMS = document.getElementById("editdiv").value;

	document.getElementById("editdiv").value = txt;
	document.getElementById("editdiv").readOnly = true;
	return;
}

function setStatusText2(txt)
{
	document.getElementById("editdiv").value = txt;
	document.getElementById("editdiv").readOnly = true;
}


function entericon(event)
{
	var icon = document.getElementById('icon');
	if (icon != null)
		icon.style.backgroundImage = "url(images/letterb.png)";
}

function exiticon(event)
{
	var icon = document.getElementById('icon');
	if (icon != null)
		icon.style.backgroundImage = "url(images/letter.png)";
}

function entereraser(event)
{
	var icon = document.getElementById('eraser');
	if (icon != null)
		icon.style.backgroundImage = "url(images/eraserb.png)";
}

function exiteraser(event)
{
	var icon = document.getElementById('eraser');
	if (icon != null)
		icon.style.backgroundImage = "url(images/eraser.png)";
}

function enterflip(event)
{
	var icon = document.getElementById('fliprollie');
	icon.style.display = 'block';
	icon.opacity = 33;
}

function exitflip(event)
{
	var icon = document.getElementById('fliprollie');
	icon.style.display = 'none';
	icon.opacity = 2;
}

function cleartext(event)
{
	buySMS = false;
	update = false;
	expired = false;
	trialAccount = false;
	
	if (status) {
		status = false;
		document.getElementById("editdiv").value = textSMS;
		document.getElementById("editdiv").readOnly = false;
		
		textSMS = "";
	} else {
		document.getElementById("editdiv").value = "";
		document.getElementById("unicode").value = "";
		document.getElementById("editdiv").readOnly = false;
		setTotal(signatureLen);
	}
}

function setTotal(n)
{
	document.getElementById("total").innerText = "#: " + n;
}

function showbackside(event)
{
	var helpPage = 'SelectHelpPage';
	var url = getLocalizedString(helpPage);
	// load web page
	// widget.openURL(url);
	widget.openURL(addCampaign(url, 'i-button', false));
}

function mousemove(event)
{
	if (!flipShown)
	{
		// fade in the flip widget
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; // set it back one frame
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.element = document.getElementById ('flip');
		animation.celement = document.getElementById ('eraser');
		animation.melement = document.getElementById ('icon');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 1.0;
		animate();
		flipShown = true;
	}

	if (!editable)
	{
		document.getElementById("editdiv").focus();
		editable = true;
	}
}

function mouseexit(event)
{
	if (flipShown)
	{
		// fade in the flip widget
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; // set it back one frame
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.element = document.getElementById ('flip');
		animation.celement = document.getElementById ('eraser');
		animation.melement = document.getElementById ('icon');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}

	if (editable)
	{
		document.getElementById("editdiv").blur();
		editable = false;
	}
}

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.element.style.opacity = animation.now;
	animation.celement.style.opacity = animation.now;
	animation.melement.style.opacity = animation.now;
}

function editclick(event)
{
	if (!editable)
	{
		document.getElementById("editdiv").focus();
		editable = true;
	}
}

function doCut(elem) {
	;
}

function doPaste(elem) {
	;
}

function setMetrics(txt)
{
	var n = 0;
	var nSMS = 0;
	var unicode = false;
	
	// determine SMS format
	if (isUnicode(txt)) {
		unicode = true;
	}
	
	// label Unicode
	if (unicode) {
		document.getElementById("unicode").innerText = "Unicode";
	} else {
		document.getElementById("unicode").innerText = "";
	}

	if (unicode) {
		n = txt.length;
	} else {
		n = gsmLength(txt);
	}

	// show number of characters	
	n = n + signatureLen;
	setTotal(n);
	
	// show number of SMS, i.e. [2] in case of Unicode SMS
	// if (unicode && n > 70) {
	//	var elem = document.getElementById("total");
	//	elem.innerText = elem.innerText + " [2 SMS]";
	// }

	nSMS = calculateNumberOfSMS(unicode, n);
	if (nSMS > 1) {
		var elem = document.getElementById("total");
		elem.innerText = elem.innerText + " [" + nSMS + " SMS]";
	}
}

function setMetrics(txt)
{
	var n = 0;
	var nSMS = 0;
	var unicode = false;
	
	// determine SMS format
	if (window.widget) {
		if (ScriptObject.isUnicode(txt)) {
			unicode = true;
		}
	}
	
	// label Unicode
	if (unicode)
		document.getElementById("unicode").innerText = "Unicode";
	else
		document.getElementById("unicode").innerText = "";

	if (unicode)
		n = txt.length;
	else
		n = gsmLength(txt);

	// show number of characters	
	n = n + signatureLen;
	setTotal(n);
	
	// show number of SMS, i.e. [2] in case of Unicode SMS
	//if (unicode && n > 70) {
		//var elem = document.getElementById("total");
		//elem.innerText = elem.innerText + " [2 SMS]";
	//}
	
	nSMS = calculateNumberOfSMS(unicode, n);
	if (nSMS > 1) {
		var elem = document.getElementById("total");
		elem.innerText = elem.innerText + " [" + nSMS + " SMS]";
	}
}


function gsmLength(txt)
{
	var sms = txt;
	var nEuros = 0;
	var len = sms.length;
        
	// there is a bug in replace regarding Euro...

    // how many Euro characters are there?
	for(var i=0;i<len;i++) {
		value = sms.charCodeAt(i);
		if (value == 8364)
			nEuros += 1;
	}
	
	// how many characters from the extension table?
	sms = sms.replace(/[\x5b\x5c\x5d\x5e\x7b\x7c\x7d\x7e]/g, "22");
	len = sms.length + nEuros;
	
	//alert("GSM Length is: " + len);
	
	return len;
}

function sendsms()
{
	var maxLen = (160 - 7) * 3;
	var maxLenUnicode = (70 - 7) * 3;
	var unicode = false;
	var callerID = null;
	var delivery = false;
	
	queryURL = "";

	// alert('calling sendsms();');

	// renew SMS Mac subscription
	if (expired) {
		if (window.widget) {	
			// widget.openURL(getLocalizedString('Renew SMS Mac')); 
			widget.openURL(addCampaign(getLocalizedString('Renew SMS Mac'), 'expired', true));
		}
		expired = false;
		return;
	}
	
	// trail SMS
	if (trialAccount) {
		doPurchaseOpenURL();
		trialAccount = false;
		return;
	}
	
	// software update
	if (update) {
		if (window.widget) {	
			// widget.openURL(productURL); 
			widget.openURL(addCampaign(productURL, 'update', false));
		}
		update = false;
		return;
	}

	// buy more SMS
	if (buySMS) {
		if (window.widget) {	
			// widget.openURL(getLocalizedString('Buy SMS'));
			widget.openURL(addCampaign(getLocalizedString('Buy SMS'), 'buy-sms', true));
		}
		buySMS = false;
		return;
	}

	// don't SMS error messages
	if (status) {
		setStatusText2(getLocalizedString('Clear'));
		return;
	}
		
	// do we have something to send?
	var txt = document.getElementById("editdiv").value;
	if (txt.length == 0)
	{
		setStatusText(getLocalizedString('NoText'));
		return;
	}
	
	// account details
	// var pin = document.getElementById("pin").value;;
	// var email = document.getElementById("mail").value;
	var pin = widget.preferenceForKey(createkey("pin"));
	var email = widget.preferenceForKey(createkey("mail"));
	
	// check PIN value
	var aNumber = Number(pin);
	if (pin.length>4 || isNaN(aNumber) || aNumber<=0 || aNumber>9999)
	{
		setStatusText(getLocalizedString('AccountError'));
		return;
	}

	// check account ID
	if (email == null || email.length == 0 || !isEmail(email))
	{
		setStatusText(getLocalizedString('AccountError'));
		return;
	} else
	{
		email = escape(email);
	}

	// get more preferences
			
	// get callerID preference
	callerID = getCallerID();
	if (callerID != null) {
		callerID = pescape(callerID);
	}

	// get delivery preference
	// delivery = getDelivery();
	delivery = widget.preferenceForKey(createkey("delivery"));
	// log("sendsms: delivery="+delivery+", "+(typeof delivery)+"\n");

	// get signature preference
	var signature;
	// signature = getSignature();
	addsignature = eval(widget.preferenceForKey(createkey("addsignature")));
	if (addsignature) {				
		// get signature
		signature = widget.preferenceForKey(createkey("signaturetxt"));
	}
	if (signature != null) {
		signatureLen = getSignatureLen(signature);
		
		// add signature
		txt = txt + signature;		
	} else
		signatureLen = 0;
		
	var mobile = "";
	var phonenumber = "";
	var phonenumbers = "";
	
	if (0 && groupSMS) {
	
		// group SMS
		
		// mobile = "Group name";
		mobile = getSelectedGroupName();
		
		// get list of mobile numbers
		if (window.widget) {
			var uid = getSelectedGroup();
			
			if (uid.length == 0) {
				setStatusText('No group is selected');
				return;
			}
			
			phonenumber = getPhoneNumbersList();
			if (phonenumber == "") {
				setStatusText(getLocalizedString('NoRecipient'));
				return;
			}
			if (phonenumber == -1) {
				setStatusText(getLocalizedString('NoPlus'));
				return;
			}
		}
		
	} else {
	
		// single SMS
		
		// phonenumber = document.getElementById("to").value;
		// phonenumber = widget.preferenceForKey(createkey("mobile"));
		phonenumber = internationalNumber(gMobile);
		if (phonenumber.length < 5)
		{
			setStatusText(getLocalizedString('NoRecipient'));
			return;
		}
		
		// used in feedback text
		mobile = phonenumber;
		
		// check configuration for email2SMS
		if (isEmail(phonenumber)) {	
		
			email2SMS = true;
			
			// var emailAddress = document.getElementById("replyemailaddress").value;
			var emailAddress = widget.preferenceForKey(createkey("replyemailaddress"));
			if (emailAddress == null || emailAddress == "") {
				setStatusText(getLocalizedString('NoReplyEmailAddress'));
				return;
			}
			
		} else {
			
			email2SMS = false;
			
			// check format of international mobile number
			if (phonenumber.charAt(0) == '+') {
				
				//phonenumber = phonenumber.substring(1);
				
			} else if (phonenumber.charAt(0) == '0' && phonenumber.charAt(1) == '0') {
				;
			} else {
				alert("mobile number not in international format.");
				setStatusText(getLocalizedString('NoPlus'));
				return;
			}
		}
	}
	
	// escape phonenumber(s)
	phonenumber = pescape(phonenumber);
	
	if (window.widget) {
		if (ScriptObject.isUnicode(txt)) {
			alert("Unicode SMS");
			unicode = true;
			maxLen = maxLenUnicode; // 3 SMS allowed when Unicode
		}	
	}

	// calculate the length of the SMS
	if (unicode)
		len = txt.length;
	else
		len = gsmLength(txt);
		
	// update total just in case
	setTotal(len);
	
	// check on SMS length
	if (len > maxLen) {
		// the SMS exceeds 160 or (70-7)*2 characters
		var message = getLocalizedString('TooMany');
		message = message.replace(/%d/i, maxLen);

		setStatusText(message);
		return;
	}
	
	txt = txt.substring(0, maxLen);

	// escape special characters
	var sms = "";
	if (window.widget) {	
		sms = escapeSMS(txt);
		// sms = ScriptObject.escape(txt);	
	}

	// initial query
	var url = "http://backend.smsmac.com/sendsms.php?prod=VSG";
	url = url + productComputerVersion;

	// build query
	url = url + "&email=" + email + "&pin=" + pin + "&destination=" + phonenumber + "&text=" + sms;

	if (email2SMS) {
	
		// var emailAddress = document.getElementById("replyemailaddress").value;
		var emailAddress = widget.preferenceForKey(createkey("replyemailaddress"));
		url = url + "&from=" + escape(emailAddress);
		
	} else {
		
		// add callerID
		if (callerID != null && callerID != "")
			url = url + "&from=" + callerID;
			
		// reply by email
		var replyIndex = getReplyValue();
		if (replyIndex == 1)
			url = url + "&reply=email"; 
	
		// add delivery
		// log("sendsms: delivery="+delivery+", "+(typeof delivery)+"\n");
		if (delivery) {
			url = url + "&deliv_ack=1";
		}
		
			// add copy SMS
		if (getCopySMS())
			url = url + "&cc=1";
	
		if (getCopySMS() || delivery) {
				
			// var reportEmailAddress = document.getElementById("report").value;
			var reportEmailAddress = widget.preferenceForKey(createkey("reportemailaddress"));
			// log("reportEmailAddress="+reportEmailAddress+"\n");
			// use account ID when not defined
			if (reportEmailAddress == null || reportEmailAddress.length == 0 || !isEmail(reportEmailAddress))
				reportEmailAddress = email;
			// log("reportEmailAddress="+reportEmailAddress+"\n");
			
			url = url + "&contact=" + escape(reportEmailAddress);
		}
		
	}

	// support concat
	var concat = calculateNumberOfSMS(unicode, len);
	if (concat > 1)
	url = url + '&concat=' + concat;

	// support Unicode
	if (unicode) {
		url = url + "&unicode=1";
		
		// if (txt.length > 70)
		//	url = url + "&concat=2";
	}
	
	// remember for fallback
	queryURL = url;

	// log query to console
	var hidePIN = url;
	hidePIN = hidePIN.replace(/pin=\d\d\d\d/, "pin=xxxx");
	alert(hidePIN);
	
	setStatusText(getLocalizedString('Sending') + ' (' + mobile + ')');
		
	// alert(url);
	// return;
	// callFallback(); return;

	// start animation
	if (drawInterval == null) {
		xpos = 0;
		step = 0;
		drawInterval = setInterval("walk();", 200);
	}
	
	if (window.XMLHttpRequest) {
		req = new XMLHttpRequest();
		req.onreadystatechange = processReqChangeXML;
		req.open("GET", url, true); // url, true
		req.setRequestHeader( "If-Modified-Since", "Sat, 1 Jan 2000 00:00:00 GMT" ); // to get around GET caching
		if (XMLHttpRequest.overrideMimeType) {               
			req.overrideMimeType('text/xml'); // added to handle XML
		}
		req.send(null);
	} else {
		alert(url);
	}

}

function handleResponse(txt)
{
	var line = "";
		
	if (txt.length == 0) {
		alert("No valid response from query");
		doErrorMessage('1000');
		return;
	} else {
		line = txt;
	}
	
	var lines = txt.split('\n');
	if (lines.length > 0) {
		line = lines[0];
	
		// NSRange range = [line1 rangeOfString:@"Software error"];
		
		txt = line.split(' ');
		
		if (txt.length > 1) {
			
			if (txt[0] == "ERR:") {
				if (txt[1] != null)
					doErrorMessage(txt[1]);
				else
					setStatusText2(line);
			} else if (txt[0] == "ID:") {
				var message;
				var n = "?";
				var days = "?";
				
				// get the second line
				if (lines.length > 1) {
					line = lines[1];
					txt = line.split(' ');
										
					// should contain number of SMS left
					if (txt.length > 1 && txt[0] == "BAL:") {
						n = txt[1];
					}
				}
								
				// get the third line
				if (lines.length > 2) {
					line = lines[2];
					txt = line.split(' ');
										
					// should contain number of days left
					if (txt.length > 1 && txt[0] == "EXP:") {
						days = txt[1];
					}
				}

				// show feedback
				if (days != "?" && days <= 21) {
				
					expired = true;
					
					// insert the number of days left
					message = getLocalizedString('Expire');
					message = message.replace(/%d/i, days);
				} else if (email2SMS) {
				
					message = getLocalizedString('SuccessEmobile');

				} else if (n != '?') {
					// insert the number of SMS left
					message = getLocalizedString('Success');
					message = message.replace(/%d/i, n);
				
					// buy more SMS
					if (n != "?") {
						var number = Number(n);
						if (number < 10) {
							message = message + " " + getLocalizedString('BuyMore');
							
							buySMS = true;
						}
					}
				}
				
				// show the SMS balance
				setStatusText2(message);
				
				// remember the fact
				hasAccount = true;
				widget.setPreferenceForKey(hasAccount, createkey("has"));
				widget.savePreferencesFile();
			} else {
				setStatusText2(getLocalizedString('kErrUnknown'));
			}
			
		} else {
			// display this line
			setStatusText2(line);
		}
		
	} else {
		// display this line
		setStatusText2(line);
	} 
	
	return;
}

function processReqChange() {

    // only if req shows "loaded"
    if (req.readyState == 4) {

		// stop animation
		if (drawInterval != null) {
			clearInterval(drawInterval);
			drawInterval = null;
		}

		clearwalk();

		// only if "OK"
        if (req.status == 200) {
            // alert(req.responseText);
            handleResponse(req.responseText);
         } else {
         	alert("req.status = " + req.status + " != 200");
            doErrorMessage('1000');
         }
    }
}

function processReqChangeXML() {
	
    // only if req shows "loaded"
    if (req.readyState == 4) {
	
		// stop animation
		if (drawInterval != null) {
			clearInterval(drawInterval);
			drawInterval = null;
		}
		clearwalk();
		// only if "OK"
        if (req.status == 200) {
            //alert(req.responseText);
	    var xml = req.responseXML;
            handleXMLResponse(xml); // plist response
         } else {
         	alert("req.status = " + req.status + " != 200");
            doErrorMessage('1000');
         }
    }
}

function handleXMLResponse(xml)
{
	
    var days = "?";
    var balance = -1;
    var message = "";
    var keyName = "";
    var dataValue = "";
    var recipients = "0";
    var errorNumber = "0";
    var success = false;
    var softwareUpdate = false;
    var softwareVersion = "";
    
	var didNotHaveAccount = hasAccount;

	var plist = xml.getElementsByTagName("plist");
    var keys = xml.getElementsByTagName("key");
	if (keys.length <= 0) {
		alert("No valid response from query");
		doErrorMessage('1000');
		return;
	} else {
		// initialize global variables 
		errorMessage = "";
		productURL = "";
		purchaseURL = getLocalizedString('Buy SMS Mac');
		trialAccount = false;
	}
	
	// find all keys	
	for (i=0;i<keys.length;i++) {
		keyName = keys[i].firstChild.nodeValue;
		// dataValue = keys[i].nextSibling.nextSibling.firstChild.data;
		dataValue = keys[i].nextSibling.firstChild.data;
				
		switch(keyName) {
			case "Error":
				success = false;
				errorNumber = dataValue;
				log("handleXMLResponse(xml): errorNumber="+errorNumber+"\n")
				break;
				
			case "ErrorMessage":
				errorMessage = dataValue;
				log("handleXMLResponse(xml): errorMessage="+errorMessage+"\n")
				break;
				
			case "ID":
				success = true;
				break;
				
			case "Balance":
				balance = Number(dataValue);
				smsbalance = balance;
				System.Gadget.Settings.write("balance", smsbalance);
				widget.setPreferenceForKey(smsbalance, createkey("balance"));
				log("handleXMLResponse(xml): smsbalance="+smsbalance+", "+typeof(smsbalance)+"\n")
				break;
				
			case "Recipients":
				recipients = dataValue;
				break;
				
			case "Expiration":
				days = dataValue;
				break;
				
			case "ProductVersion":
				softwareVersion = dataValue;
				softwareUpdate = true;
				break;
				
			case "ProductURL":
				productURL = dataValue;
				break;

			case "PurchaseURL":
				purchaseURL = dataValue; // global variable
				purchaseURL = purchaseURL + getLocalizedString('Locale');
				break;
				
			case "Trial":
				trialAccount = true; // global variable
				break;
				
			default:
				break;
		} // of switch
	} // of for loop
	
	
	// an error occurred
	if (!success) {
		doErrorMessage(errorNumber);
		return;
	}
	
	// success
	
	// expiration is near
	if (days != "?" && days <= 21 && trialAccount == false) {
	
		expired = true;
		
		// insert the number of days left
		message = getLocalizedString('Expire');
		message = message.replace(/%d/i, days);
		
		hasAccount = true;
		widget.setPreferenceForKey(hasAccount, createkey("has"));
		widget.savePreferencesFile();
		
	} else if (email2SMS) {
	
		message = getLocalizedString('SuccessEmobile');
	
	// show balance
	} else if (balance != -1) {
	
		// insert the number of SMS left
		if (recipients != "0" && recipients != "1") {
		
			message = getLocalizedString('SuccessN');
			message = message.replace(/%n/i, recipients);
			message = message.replace(/%d/i, balance);

		} else {
		
			message = getLocalizedString('Success');
			message = message.replace(/%d/i, balance);
			
		}
		
		// buy more SMS
		var number = Number(balance);
		if (number < 10) {
		
			buySMS = true;
			
			// buy more SMS
			message = message + " " + getLocalizedString('BuyMore');
			
			// trial SMS
			if (trialAccount) {
			
				if (number == 0) {
					message = getLocalizedString('TrialEnd');
				} else {
					message = getLocalizedString('TrialPeriod');
					message = message.replace(/%d/i, balance);
				}
				
				buySMS = false;
			}

		} else if (softwareUpdate) {
		
			update = true;
			
			// software update
			var remark = getLocalizedString('NewVersion');
			remark = remark.replace(/%s/i, softwareVersion);
			message = message + " " + remark;
			
		}
		
		hasAccount = true;
		widget.setPreferenceForKey(hasAccount, createkey("has"));
		widget.savePreferencesFile();
	}
	
	// not in this case
	if (trialAccount) {
		hasAccount = false;
	}

	// update strings between Buy SMS Mac and Buy SMS
	// if (hasAccount && didNotHaveAccount == false) {
	//	updateHasAccountStatus(true);
	// }
	
	// show the SMS balance
	setStatusText2(message);
}


function getCopySMS() {
	// return document.getElementById("copysms").checked;
	return widget.preferenceForKey(createkey("copysms"));
}


function getCallerID() {
	var callerID = "";
	
	var index = getReplyValue();
	switch(index) {
		case 0:
			// callerID = document.getElementById("caller").value;
			callerID = widget.preferenceForKey(createkey("caller"));
			break;
			
		case 1:
			// callerID = document.getElementById("replyemailaddress").value;
			callerID = widget.preferenceForKey(createkey("replyemailaddress"));
			break;

		case 2:
			// usealphanumericID = document.getElementById("usealphanumericID").checked;
			usealphanumericID = widget.preferenceForKey(createkey("usealphanumericID"));
			if (usealphanumericID) {
				// callerID = document.getElementById("alphanumericID").value;
				callerID = widget.preferenceForKey(createkey("alphanumericID"));
				if (callerID != "") {
				
					// accept only alphanumeric format
					callerID = callerID.replace(/[^\w.]/g, "");
					
					// feedback
					// document.getElementById("alphanumericID").value = callerID;
					
					// cut it
					if (callerID.length > 11)
						callerID = callerID.substring(0, 11);
				}
			}
			break;
	}

	if (callerID.length > 0)
		return callerID;
		
	return null;
}

function pescape(s) {
	s = escape(s);
	return s.replace(/\+/g, '%2B');
}

var eudora = new Image(19, 13);
eudora.src = 'images/letterb.png';

function walk()
{
	// debugger;
	// return;
	var canvas = document.getElementById("canvas");
	var context = canvas.getContext("2d");

	var w = canvas.style.width;
	w = Number(w.replace('px','')); // convert from px to number

	context.clearRect (0, 0, w, canvas.style.heigth);

	// log("walk: xpos="+xpos+", canvas.style.width="+w+"\n");
	
	context.save();
	context.drawImage(eudora, xpos, 0, 19, 13);// x, y, width, height
	xpos += 20;
	
	// log("walk: xpos="+xpos+", "+typeof(xpos)+", canvas.style.width="+w+", "+typeof(w)+"\n")
	if (xpos > w-20) {
		xpos = 0;		
		// log("walk: xpos="+xpos+", canvas.style.width="+w+"\n");
	}

	context.restore();
}

function clearwalk()
{
	// return;
	var canvas = document.getElementById("canvas");
	var context = canvas.getContext("2d");
	
	context.clearRect (0, 0, canvas.style.width, canvas.style.heigth);
}

function doErrorMessage(error)
{
	switch(error) {
		case '105':
			setStatusText2(getLocalizedString('kErrInvalidDestination'));
			break;
		
		case '106':
			setStatusText2(getLocalizedString('kErrInvalidSenderID'));
			break;
		
		case '1000':
			setStatusText2(getLocalizedString('kErrNoInternet'));
			break;
			
		case '1001':
			setStatusText2(getLocalizedString('kErrAuthenticationFailed'));
			break;
			
		case '1002':
			var msg;
			
			if (trialAccount) {
				msg = getLocalizedString('TrialEnd');
			} else {
				msg = getLocalizedString('kErrNoTicksLeft');
			}
			
			setStatusText2(msg);
			break;
			
		case '1003':
			setStatusText2(getLocalizedString('kErrAccountFrozen'));
			break;
			
		case '1004':
			setStatusText2(getLocalizedString('kErrAccountingDB'));
			break;
			
		case '1011':
			setStatusText2(getLocalizedString('kErrConnectDB'));
			break;
			
		case '1018':
			var msg;
			
			if (trialAccount) {
				msg = getLocalizedString('TrialExpired');
			} else {
				expired = true;
				msg = getLocalizedString('kErrExpired');
			}
			
			setStatusText2(msg);
			break;
			
		case '1025':
			setStatusText2(getLocalizedString('kErrGatewayUnreachable'));
			break;
			
		case '1050':
			setStatusText2(getLocalizedString('kErrNumberTiedToOtherAccount'));
			break;
			
		case '1060':
			setStatusText2(getLocalizedString('kErrTooManyRecipients'));
			break;
			
		case '1061':
			setStatusText2(getLocalizedString('kErrTooManyQueries'));
			break;
			
		case '5000':
			setStatusText2(getLocalizedString('kErrSMSScriptCrash'));
			break;
			
		case '6001':
			setStatusText2(getLocalizedString('kErrFeatureNotSupported') + 'Unicode.');
			break;
			
		case '6002':
			setStatusText2(getLocalizedString('kErrFeatureNotSupported') + 'Long SMS.');
			break;
			
		case '6004':
			setStatusText2(getLocalizedString('kErrFeatureNotSupported') + 'Flash.');
			break;
			
		case '6008':
			setStatusText2(getLocalizedString('kErrReplyByEmailNotSupported'));
			break;
			
		case '1097':
			callFallback();
			break;
			
		default:
			var msg = getLocalizedString('kError') + error;
			if (errorMessage != "")
				msg = msg + ". " + errorMessage;

			setStatusText2(msg);
			break;
	}
}

function callFallback()
{
	var len = queryURL.length;
	var questionMark = queryURL.indexOf('?');
	var fbURL = queryURL.substring(questionMark, len);
	fbURL = "http://www.smsmac.com/cgi-bin/fb/sms" + fbURL;

	fbURL = fbURL.replace(/\&destination=/, "&to=");
	
	// alert('calling fallback');
	
	// log query to console
	var hidePIN = fbURL;
	hidePIN = hidePIN.replace(/pin=\d\d\d\d/, "pin=xxxx");
	alert(hidePIN);
		
	// start animation
	if (drawInterval == null) {
		xpos = 0;
		step = 0;
		drawInterval = setInterval("walk();", 200);
	}
	
    if (window.XMLHttpRequest) {
        req = new XMLHttpRequest();
        req.onreadystatechange = processReqChange;
        req.open("GET", fbURL, true);
        req.send(null);
	} else {
		alert(fbURL);
	}
}

// Are we inside the sidebar or on the desktop?
function checkState() {
	// log("checkState()\n")
	if (!System.Gadget.docked) {
		setBackgroundImage();
		unDockedState();
	} else {
		setBackgroundImage();		
		dockedState();
	}
}

function dockedState() {
	
	// log("dockedState()\n");

	document.body.style.width = "128px";
	document.body.style.height = "149px";

	oBackground = document.getElementById("imgBackground");
	oBackground.style.width = "128px";
	oBackground.style.height = "149px";

	elem = document.getElementById('head');
	elem.style.top = "7px";
	elem.style.left = "7px";
	elem.style.width = "108px";
	elem.style.height = "11px";
	elem.style.fontSize = "9px";

	elem = document.getElementById('editdiv');
	elem.style.top = "21px";
	elem.style.left = "8px";
	elem.style.width = "108px";
	elem.style.height = "82px";
	// elem.style.overflow = "hidden";
	elem.style.fontSize = "9px";

	elem = document.getElementById('canvas');
	elem.style.top = "60px";
	elem.style.left = "9px";
	elem.style.width = "100px";
	elem.style.height = "40px";
	
	elem = document.getElementById('total');
	elem.style.top = "105px";
	elem.style.left = "9px";
	elem.style.height = "12px";
	elem.style.color = '#999999';
	elem.style.fontSize = "9px";

	elem = document.getElementById('unicode');
	elem.style.top = "105px";
	elem.style.left = "82px";
	elem.style.height = "12px";
	elem.style.color = '#999999';
	elem.style.fontSize = "9px";

	elem = document.getElementById('icon');
	elem.style.top = "127px";
	elem.style.left = "26px";
	elem.style.width = "19px";
	elem.style.height = "13px";

	elem = document.getElementById('eraser');
	elem.style.top = "127px";
	elem.style.left = "84px";
	elem.style.width = "19px";
	elem.style.height = "13px";

	elem = document.getElementById('flip');
	elem.style.visibility = "hidden";

	// log("dockedState(): done\n");
}

function unDockedState() {
	
	// log("unDockedState()\n");

	document.body.style.width = "180px";
	document.body.style.height = "265px";

	oBackground = document.getElementById("imgBackground");
	oBackground.style.width = "180px";
	oBackground.style.height = "265px";

	elem = document.getElementById('head');
	elem.style.top = "31px";
	elem.style.left = "30px";
	elem.style.width = "125px";
	elem.style.height = "16px";
	elem.style.fontSize = "14px";

	elem = document.getElementById('editdiv');
	elem.style.top = "51px";
	elem.style.left = "29px";
	elem.style.width = "124px";
	elem.style.height = "125px";
	// elem.style.overflow = "hidden";
	elem.style.fontSize = "12px";
	
	elem = document.getElementById('canvas');
	elem.style.top = "100px";
	elem.style.left = "30px";
	elem.style.width = "125px";
	elem.style.height = "40px";

	elem = document.getElementById('total');
	elem.style.top = "178px";
	elem.style.left = "30px";
	elem.style.height = "12px";
	elem,color = '#999999';
	elem.style.fontSize = "10px";

	elem = document.getElementById('unicode');
	elem.style.top = "178px";
	elem.style.left = "115px";
	elem.style.height = "12px";
	elem.style.color = '#999999';
	elem.style.fontSize = "10px";

	elem = document.getElementById('icon');
	elem.style.top = "206px";
	elem.style.left = "82px";
	elem.style.width = "19px";
	elem.style.height = "13px";

	elem = document.getElementById('eraser');
	elem.style.top = "215px";
	elem.style.left = "120px";
	elem.style.width = "19px";
	elem.style.height = "13px";

	elem = document.getElementById('flip');
	elem.style.top = "215px";
	elem.style.left = "43px";
	elem.style.width = "13px";
	elem.style.height = "13px";
	elem.style.visibility = "visible";


	// log("unDockedState(): done\n");

}

function showMenu(){
}

function calculateNumberOfSMS(unicode, nChars) {
    var nSMS = 0;
    
    var len = lengthOfOneSMS(unicode)
    
    if (nChars <= len)
        nSMS = 1;
    else {
        // 7 octets = 7 * 8 = 56 bits, 56 bits / 7 bits = 8 characters in the GSM 7bit character set
        if (unicode)
            len = 70 - 7;
        else
            len = 160 - 7; // with testing it seems 153 can be contained
            
        nSMS = Math.floor(nChars / len );
        
        if ((nChars % len) != 0)
            nSMS += 1;
    }
        
    return nSMS;
}

function lengthOfOneSMS(unicode) {
    var len = 0;
    
    if (unicode)
        len = 70;
    else
        len = 160;
        
    return len;
}

function addCampaign(url, campaignName, addAccount) {
	
       // Google Analytics Campaign
       var productCode = "VSG" + productComputerVersion;

       url = url + "&utm_source=vista_sidebar&utm_medium=software&utm_content=" +
             productCode +"&utm_campaign=" + campaignName;

       if (addAccount) {
               var email = widget.preferenceForKey(createkey("mail"));
               if (email != null && email.length != 0) {
                       email = escape(email);
                       url = url + "&account=" + email;
               }
       }

       alert(url);
       return url;
}

function setTooltips() {
	// tooltips
	// log("setTooltips()\n");
	setHeadTooltip(getHeader(), getMobile());
	document.getElementById('editdiv').title = getLocalizedString('Enter Text Here');
	document.getElementById('total').title = getLocalizedString('Number Of Characters');
	document.getElementById('unicode').title = getLocalizedString('Unicode Indicator');
	document.getElementById('icon').title = getLocalizedString('Send SMS');
	document.getElementById('eraser').title = getLocalizedString('Erase Screen');
	document.getElementById('flip').title = getLocalizedString('Edit Preferences');
	// log("setTooltips(): done\n");
}

function setHeadTooltip(name, mobile)
{
	// log("setHeadTooltip: name="+name+", mobile="+mobile+"\n");
	var toolTip = getLocalizedString('Mobile Number');
	if (toolTip) {
		toolTip = toolTip.replace(/%s/i, name);
		toolTip = toolTip.replace(/%d/i, mobile);
		
		setHeaderTooltip(toolTip);
	}
}

function setHeaderTooltip(title)
{	
	// log("setHeaderTooltip: title="+title+"\n");
	var head = document.getElementById("head");
	head.title = title;
}

function doPurchaseOpenURL() {
	if (window.widget) {
		var url = addCampaign(purchaseURL, 'trialsms', true);
		widget.openURL(url);
	}
}
